@import "velvet-settings.scss";

//MIXINS
@mixin for-size($range) {
	@if $range == xs {
		@content;
	}
	@else if $range == xs-only {
		@media (max-width: $sm-boundary - 1) {
			@content;
		}
	}
	@else if $range == sm {
		@media (min-width: $sm-boundary) {
			@content;
		}
	}
	@else if $range == sm-only {
		@media (min-width: $sm-boundary) and (max-width: $md-boundary - 1) {
			@content;
		}
	}
	@else if $range == md {
		@media (min-width: $md-boundary) {
			@content;
		}
	}
	@else if $range == md-only {
		@media (min-width: $md-boundary) and (max-width: $lg-boundary - 1) {
			@content;
		}
	}
	@else if $range == lg {
		@media (min-width: $lg-boundary) {
			@content;
		}
	}
	@else if $range == lg-only {
		@media (min-width: $lg-boundary) and (max-width: $xl-boundary - 1) {
			@content;
		}
	}
	@else if $range == xl {
		@media (min-width: $xl-boundary) {
			@content;
		}
	}
}

@mixin box-sizing($values) {
	box-sizing: $values;
	-moz-box-sizing: $values;
	-webkit-box-sizing: $values;
	-o-box-sizing: $values;
}

//VELVET GRID
* {
	margin: 0;
	padding: 0;
	text-decoration: none;
	outline: none;
	@include box-sizing(border-box);
}

.v-grid {
	display: grid;
	grid-column-gap: $gap-columns;
	grid-row-gap: $gap-rows;
	width: 100%;
	max-width: $max-width;
	height: auto;
	margin: 0 auto;
	padding: $gap-grid;
	grid-template-rows: auto;
	
	
	&[data-flow='column'] {
		grid-auto-flow: column;
	}
	
	&[data-flow='row'] {
		grid-auto-flow: row;
	}
	
	//XS – EVENLY COLUMNS
	@for $i from 1 through $max-columns {
		&[data-xs-columns='#{$i}'] {
			grid-template-columns: repeat($i, 1fr);
		}
	}
	
	//XS – EVENLY ROWS
	@for $i from 1 through $max-rows {
		&[data-xs-rows='#{$i}'] {
			grid-template-rows: repeat($i, 1fr);
		}
	}
	
	//XS – ALIGN ITEMS
	&[data-xs-align-items='stretch'] {
		align-items: stretch;
	}
	
	&[data-xs-align-items='center'] {
		align-items: center;
	}
	
	&[data-xs-align-items='start'] {
		align-items: start;
	}
	
	&[data-xs-align-items='end'] {
		align-items: end;
	}
	
	@include for-size(sm) {
		
		//SM – EVENLY COLUMNS
		@for $i from 1 through $max-columns {
			&[data-sm-columns='#{$i}'] {
				grid-template-columns: repeat($i, 1fr);
			}
		}
		
		//SM – EVENLY ROWS
		@for $i from 1 through $max-rows {
			&[data-sm-rows='#{$i}'] {
				grid-template-rows: repeat($i, 1fr);
			}
		}
		
		//SM – ALIGN ITEMS
		&[data-sm-align-items='stretch'] {
			align-items: stretch;
		}
		
		&[data-sm-align-items='center'] {
			align-items: center;
		}
		
		&[data-sm-align-items='start'] {
			align-items: start;
		}
		
		&[data-sm-align-items='end'] {
			align-items: end;
		}
		
	};
	
	@include for-size(md) {
		
		//MD – EVENLY COLUMNS
		@for $i from 1 through $max-columns {
			&[data-md-columns='#{$i}'] {
				grid-template-columns: repeat($i, 1fr);
			}
		}
		
		//MD – EVENLY ROWS
		@for $i from 1 through $max-rows {
			&[data-md-rows='#{$i}'] {
				grid-template-rows: repeat($i, 1fr);
			}
		}
		
		//MD – ALIGN ITEMS
		&[data-md-align-items='stretch'] {
			align-items: stretch;
		}
		
		&[data-md-align-items='center'] {
			align-items: center;
		}
		
		&[data-md-align-items='start'] {
			align-items: start;
		}
		
		&[data-md-align-items='end'] {
			align-items: end;
		}
		
	};
	
	@include for-size(lg) {
		
		//LG – EVENLY COLUMNS
		@for $i from 1 through $max-columns {
			&[data-lg-columns='#{$i}'] {
				grid-template-columns: repeat($i, 1fr);
			}
		}
		
		//LG – EVENLY ROWS
		@for $i from 1 through $max-rows {
			&[data-lg-rows='#{$i}'] {
				grid-template-rows: repeat($i, 1fr);
			}
		}
		
		//LG – ALIGN ITEMS
		&[data-lg-align-items='stretch'] {
			align-items: stretch;
		}
		
		&[data-lg-align-items='center'] {
			align-items: center;
		}
		
		&[data-lg-align-items='start'] {
			align-items: start;
		}
		
		&[data-lg-align-items='end'] {
			align-items: end;
		}
		
	};
	
	@include for-size(xl) {
		
		//XL – EVENLY COLUMNS
		@for $i from 1 through $max-columns {
			&[data-xl-columns='#{$i}'] {
				grid-template-columns: repeat($i, 1fr);
			}
		}
		
		//XL – EVENLY ROWS
		@for $i from 1 through $max-rows {
			&[data-xl-rows='#{$i}'] {
				grid-template-rows: repeat($i, 1fr);
			}
		}
		
		//XL – ALIGN ITEMS
		&[data-xl-align-items='stretch'] {
			align-items: stretch;
		}
		
		&[data-xl-align-items='center'] {
			align-items: center;
		}
		
		&[data-xl-align-items='start'] {
			align-items: start;
		}
		
		&[data-xl-align-items='end'] {
			align-items: end;
		}
		
	};
}

.v-cell {
	
	//XS – COLUMN SPAN
	@for $i from 1 through $max-columns {
		&[data-xs-column-span='#{$i}'] {
			grid-column: span $i;
		}
	}
	
	//XS COLUMN START
	@for $i from 1 through $max-columns {
		&[data-xs-column-start='#{$i}'] {
			grid-column-start: $i;
		}
	}
	&[data-xs-column-start='first'] {
		grid-column-start: first;
	}
	
	//XS COLUMN END
	@for $i from 1 through $max-columns {
		&[data-xs-column-end='#{$i}'] {
			grid-column-end: $i;
		}
	}
	&[data-xs-column-end='end'] {
		grid-column-end: end;
	}
	
	//XS – ROW SPAN
	@for $i from 1 through $max-rows {
		&[data-xs-row-span='#{$i}'] {
			grid-row: span $i;
		}
	}
	
	//XS ROW START
	@for $i from 1 through $max-columns {
		&[data-xs-row-start='#{$i}'] {
			grid-row-start: $i;
		}
	}
	
	//XS ROW END
	@for $i from 1 through $max-columns {
		&[data-xs-row-end='#{$i}'] {
			grid-row-end: $i;
		}
	}
	
	@include for-size(sm) {
		
		//SM – COLUMN SPAN
		@for $i from 1 through $max-columns {
			&[data-sm-column-span='#{$i}'] {
				grid-column: span $i;
			}
		}
		
		//SM COLUMN START
		@for $i from 1 through $max-columns {
			&[data-sm-column-start='#{$i}'] {
				grid-column-start: $i;
			}
		}
		&[data-sm-column-start='first'] {
			grid-column-start: first;
		}
		
		//SM COLUMN END
		@for $i from 1 through $max-columns {
			&[data-sm-column-end='#{$i}'] {
				grid-column-end: $i;
			}
		}
		&[data-sm-column-end='end'] {
			grid-column-end: end;
		}
		
		//SM – ROW SPAN
		@for $i from 1 through $max-rows {
			&[data-sm-row-span='#{$i}'] {
				grid-row: span $i;
			}
		}
		
		//SM ROW START
		@for $i from 1 through $max-columns {
			&[data-sm-row-start='#{$i}'] {
				grid-row-start: $i;
			}
		}
		
		//SM ROW END
		@for $i from 1 through $max-columns {
			&[data-sm-row-end='#{$i}'] {
				grid-row-end: $i;
			}
		}
		
	};
	
	@include for-size(md) {
		
		//MD – COLUMN SPAN
		@for $i from 1 through $max-columns {
			&[data-md-column-span='#{$i}'] {
				grid-column: span $i;
			}
		}
		
		//MD COLUMN START
		@for $i from 1 through $max-columns {
			&[data-md-column-start='#{$i}'] {
				grid-column-start: $i;
			}
		}
		&[data-md-column-start='first'] {
			grid-column-start: first;
		}
		
		//MD COLUMN END
		@for $i from 1 through $max-columns {
			&[data-md-column-end='#{$i}'] {
				grid-column-end: $i;
			}
		}
		&[data-md-column-end='end'] {
			grid-column-end: end;
		}
		
		//MD – ROW SPAN
		@for $i from 1 through $max-rows {
			&[data-md-row-span='#{$i}'] {
				grid-row: span $i;
			}
		}
		
		//MD ROW START
		@for $i from 1 through $max-columns {
			&[data-md-row-start='#{$i}'] {
				grid-row-start: $i;
			}
		}
		
		//MD ROW END
		@for $i from 1 through $max-columns {
			&[data-md-row-end='#{$i}'] {
				grid-row-end: $i;
			}
		}
		
	};
	
	@include for-size(lg) {
		
		//LG – COLUMN SPAN
		@for $i from 1 through $max-columns {
			&[data-lg-column-span='#{$i}'] {
				grid-column: span $i;
			}
		}
		
		//LG COLUMN START
		@for $i from 1 through $max-columns {
			&[data-lg-column-start='#{$i}'] {
				grid-column-start: $i;
			}
		}
		&[data-lg-column-start='first'] {
			grid-column-start: first;
		}
		
		//LG COLUMN END
		@for $i from 1 through $max-columns {
			&[data-lg-column-end='#{$i}'] {
				grid-column-end: $i;
			}
		}
		&[data-lg-column-end='end'] {
			grid-column-end: end;
		}
		
		//LG – ROW SPAN
		@for $i from 1 through $max-rows {
			&[data-lg-row-span='#{$i}'] {
				grid-row: span $i;
			}
		}
		
		//LG ROW START
		@for $i from 1 through $max-columns {
			&[data-lg-row-start='#{$i}'] {
				grid-row-start: $i;
			}
		}
		
		//LG ROW END
		@for $i from 1 through $max-columns {
			&[data-lg-row-end='#{$i}'] {
				grid-row-end: $i;
			}
		}
		
	};
	
	@include for-size(xl) {
		
		//XL – COLUMN SPAN
		@for $i from 1 through $max-columns {
			&[data-xl-column-span='#{$i}'] {
				grid-column: span $i;
			}
		}
		
		//XL COLUMN START
		@for $i from 1 through $max-columns {
			&[data-xl-column-start='#{$i}'] {
				grid-column-start: $i;
			}
		}
		&[data-xl-column-start='first'] {
			grid-column-start: first;
		}
		
		//XL COLUMN END
		@for $i from 1 through $max-columns {
			&[data-xl-column-end='#{$i}'] {
				grid-column-end: $i;
			}
		}
		&[data-xl-column-end='end'] {
			grid-column-end: end;
		}
		
		//XL – ROW SPAN
		@for $i from 1 through $max-rows {
			&[data-xl-row-span='#{$i}'] {
				grid-row: span $i;
			}
		}
		
		//XL ROW START
		@for $i from 1 through $max-columns {
			&[data-xl-row-start='#{$i}'] {
				grid-row-start: $i;
			}
		}
		
		//XL ROW END
		@for $i from 1 through $max-columns {
			&[data-xl-row-end='#{$i}'] {
				grid-row-end: $i;
			}
		}
		
	};
}
